# coding: utf-8

"""
    DCS (Gitea) API.

    This documentation describes the DCS (Gitea) API.  # noqa: E501

    OpenAPI spec version: 1.20.3+dcs
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from dcs_api_client.api_client import ApiClient


class CatalogApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def catalog_get_entry(self, owner, repo, ref, **kwargs):  # noqa: E501
        """Catalog entry  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_get_entry(owner, repo, ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: name of the owner (required)
        :param str repo: name of the repo (required)
        :param str ref: release tag or default branch (required)
        :return: CatalogEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_get_entry_with_http_info(owner, repo, ref, **kwargs)  # noqa: E501
        else:
            (data) = self.catalog_get_entry_with_http_info(owner, repo, ref, **kwargs)  # noqa: E501
            return data

    def catalog_get_entry_with_http_info(self, owner, repo, ref, **kwargs):  # noqa: E501
        """Catalog entry  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_get_entry_with_http_info(owner, repo, ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: name of the owner (required)
        :param str repo: name of the repo (required)
        :param str ref: release tag or default branch (required)
        :return: CatalogEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'ref']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_get_entry" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if self.api_client.client_side_validation and ('owner' not in params or
                                                       params['owner'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `owner` when calling `catalog_get_entry`")  # noqa: E501
        # verify the required parameter 'repo' is set
        if self.api_client.client_side_validation and ('repo' not in params or
                                                       params['repo'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `repo` when calling `catalog_get_entry`")  # noqa: E501
        # verify the required parameter 'ref' is set
        if self.api_client.client_side_validation and ('ref' not in params or
                                                       params['ref'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `ref` when calling `catalog_get_entry`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']  # noqa: E501
        if 'repo' in params:
            path_params['repo'] = params['repo']  # noqa: E501
        if 'ref' in params:
            path_params['ref'] = params['ref']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/entry/{owner}/{repo}/{ref}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CatalogEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_get_metadata(self, owner, repo, ref, **kwargs):  # noqa: E501
        """Catalog entry metadata (manifest.yaml in JSON format)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_get_metadata(owner, repo, ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: name of the owner (required)
        :param str repo: name of the repo (required)
        :param str ref: release tag or default branch (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_get_metadata_with_http_info(owner, repo, ref, **kwargs)  # noqa: E501
        else:
            (data) = self.catalog_get_metadata_with_http_info(owner, repo, ref, **kwargs)  # noqa: E501
            return data

    def catalog_get_metadata_with_http_info(self, owner, repo, ref, **kwargs):  # noqa: E501
        """Catalog entry metadata (manifest.yaml in JSON format)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_get_metadata_with_http_info(owner, repo, ref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: name of the owner (required)
        :param str repo: name of the repo (required)
        :param str ref: release tag or default branch (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'ref']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_get_metadata" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if self.api_client.client_side_validation and ('owner' not in params or
                                                       params['owner'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `owner` when calling `catalog_get_metadata`")  # noqa: E501
        # verify the required parameter 'repo' is set
        if self.api_client.client_side_validation and ('repo' not in params or
                                                       params['repo'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `repo` when calling `catalog_get_metadata`")  # noqa: E501
        # verify the required parameter 'ref' is set
        if self.api_client.client_side_validation and ('ref' not in params or
                                                       params['ref'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `ref` when calling `catalog_get_metadata`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']  # noqa: E501
        if 'repo' in params:
            path_params['repo'] = params['repo']  # noqa: E501
        if 'ref' in params:
            path_params['ref'] = params['ref']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/entry/{owner}/{repo}/{ref}/metadata', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_list_languages(self, **kwargs):  # noqa: E501
        """Catalog list owners  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_list_languages(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: list only lannguages with entries in the given owners(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str lang: list only the given languages(s) if they have entries in the catalog meeting the criteria given (e.g. way to test an language has a given owner and/or subject)
        :param str stage: list only languages of the given stage or lower, with low to high being: \"prod\" - return only the production subjects (default); \"preprod\" - return pre-production and production subjects; \"draft\" - return only draft, pre-product and production subjects; \"latest\" - return all subjects in the catalog for all stages
        :param str subject: list only languages with the the given subject(s). Multiple resources are ORed.
        :param str resource: list only languages with the given resource identifier(s). Multiple resources are ORed.
        :param str format: list only languages with the given content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: list only for languages with the given checking level(s). Can be 1, 2 or 3
        :param str book: list only languages with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: list only languages with the given metadata type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: list only languages with the  given metadatay version. Does not apply if metadataType is \"all\" or empty
        :param str direction: list only languages of the given language direction, \"ltr\" or \"rtl\".
        :param bool is_gl: list only languages of they are (true) or are not (false) a gatetway language.
        :param bool partial_match: if true, owner, language and subject search fields will use partial match (LIKE) when querying the catalog. Default is false
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_list_languages_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.catalog_list_languages_with_http_info(**kwargs)  # noqa: E501
            return data

    def catalog_list_languages_with_http_info(self, **kwargs):  # noqa: E501
        """Catalog list owners  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_list_languages_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: list only lannguages with entries in the given owners(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str lang: list only the given languages(s) if they have entries in the catalog meeting the criteria given (e.g. way to test an language has a given owner and/or subject)
        :param str stage: list only languages of the given stage or lower, with low to high being: \"prod\" - return only the production subjects (default); \"preprod\" - return pre-production and production subjects; \"draft\" - return only draft, pre-product and production subjects; \"latest\" - return all subjects in the catalog for all stages
        :param str subject: list only languages with the the given subject(s). Multiple resources are ORed.
        :param str resource: list only languages with the given resource identifier(s). Multiple resources are ORed.
        :param str format: list only languages with the given content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: list only for languages with the given checking level(s). Can be 1, 2 or 3
        :param str book: list only languages with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: list only languages with the given metadata type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: list only languages with the  given metadatay version. Does not apply if metadataType is \"all\" or empty
        :param str direction: list only languages of the given language direction, \"ltr\" or \"rtl\".
        :param bool is_gl: list only languages of they are (true) or are not (false) a gatetway language.
        :param bool partial_match: if true, owner, language and subject search fields will use partial match (LIKE) when querying the catalog. Default is false
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'lang', 'stage', 'subject', 'resource', 'format', 'checking_level', 'book', 'metadata_type', 'metadata_version', 'direction', 'is_gl', 'partial_match']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_list_languages" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'owner' in params:
            query_params.append(('owner', params['owner']))  # noqa: E501
        if 'lang' in params:
            query_params.append(('lang', params['lang']))  # noqa: E501
        if 'stage' in params:
            query_params.append(('stage', params['stage']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'resource' in params:
            query_params.append(('resource', params['resource']))  # noqa: E501
        if 'format' in params:
            query_params.append(('format', params['format']))  # noqa: E501
        if 'checking_level' in params:
            query_params.append(('checkingLevel', params['checking_level']))  # noqa: E501
        if 'book' in params:
            query_params.append(('book', params['book']))  # noqa: E501
        if 'metadata_type' in params:
            query_params.append(('metadataType', params['metadata_type']))  # noqa: E501
        if 'metadata_version' in params:
            query_params.append(('metadataVersion', params['metadata_version']))  # noqa: E501
        if 'direction' in params:
            query_params.append(('direction', params['direction']))  # noqa: E501
        if 'is_gl' in params:
            query_params.append(('isGL', params['is_gl']))  # noqa: E501
        if 'partial_match' in params:
            query_params.append(('partialMatch', params['partial_match']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/owners', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_list_subjects(self, **kwargs):  # noqa: E501
        """Catalog list subjects  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_list_subjects(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: list only subjects in the given owner(s). To match multiple, give the parameter multiple times or give a list comma delimited.
        :param str lang: list only subjects in the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: list only subjects of the given stage or lower, with low to high being: \"prod\" - return only the production subjects (default); \"preprod\" - return pre-production and production subjects; \"draft\" - return only draft, pre-product and production subjects; \"latest\" - return all subjects in the catalog for all stages
        :param str subject: list only the given subjects if they are in the catalog meeting the criteria given (e.g. way to test a given language has the given subject)
        :param str resource: list only subjects with the given resource identifier. Multiple resources are ORed.
        :param str format: list only subjects with the given content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: list only for subjects with the given checking level(s). Can be 1, 2 or 3
        :param str book: list only subjects with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: list only subjects with the given metadata type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: list only subjects with the  given metadatay version. Does not apply if metadataType is \"all\" or empty
        :param bool partial_match: if true, owner, subject and language search fields will use partial match (LIKE) when querying the catalog. Default is false
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_list_subjects_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.catalog_list_subjects_with_http_info(**kwargs)  # noqa: E501
            return data

    def catalog_list_subjects_with_http_info(self, **kwargs):  # noqa: E501
        """Catalog list subjects  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_list_subjects_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: list only subjects in the given owner(s). To match multiple, give the parameter multiple times or give a list comma delimited.
        :param str lang: list only subjects in the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: list only subjects of the given stage or lower, with low to high being: \"prod\" - return only the production subjects (default); \"preprod\" - return pre-production and production subjects; \"draft\" - return only draft, pre-product and production subjects; \"latest\" - return all subjects in the catalog for all stages
        :param str subject: list only the given subjects if they are in the catalog meeting the criteria given (e.g. way to test a given language has the given subject)
        :param str resource: list only subjects with the given resource identifier. Multiple resources are ORed.
        :param str format: list only subjects with the given content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: list only for subjects with the given checking level(s). Can be 1, 2 or 3
        :param str book: list only subjects with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: list only subjects with the given metadata type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: list only subjects with the  given metadatay version. Does not apply if metadataType is \"all\" or empty
        :param bool partial_match: if true, owner, subject and language search fields will use partial match (LIKE) when querying the catalog. Default is false
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'lang', 'stage', 'subject', 'resource', 'format', 'checking_level', 'book', 'metadata_type', 'metadata_version', 'partial_match']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_list_subjects" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'owner' in params:
            query_params.append(('owner', params['owner']))  # noqa: E501
        if 'lang' in params:
            query_params.append(('lang', params['lang']))  # noqa: E501
        if 'stage' in params:
            query_params.append(('stage', params['stage']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'resource' in params:
            query_params.append(('resource', params['resource']))  # noqa: E501
        if 'format' in params:
            query_params.append(('format', params['format']))  # noqa: E501
        if 'checking_level' in params:
            query_params.append(('checkingLevel', params['checking_level']))  # noqa: E501
        if 'book' in params:
            query_params.append(('book', params['book']))  # noqa: E501
        if 'metadata_type' in params:
            query_params.append(('metadataType', params['metadata_type']))  # noqa: E501
        if 'metadata_version' in params:
            query_params.append(('metadataVersion', params['metadata_version']))  # noqa: E501
        if 'partial_match' in params:
            query_params.append(('partialMatch', params['partial_match']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/subjects', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_search(self, **kwargs):  # noqa: E501
        """Catalog search  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str owner: search only for entries with the given owner name(s). Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str repo: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" - return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_search_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.catalog_search_with_http_info(**kwargs)  # noqa: E501
            return data

    def catalog_search_with_http_info(self, **kwargs):  # noqa: E501
        """Catalog search  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str owner: search only for entries with the given owner name(s). Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str repo: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" - return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['q', 'owner', 'repo', 'tag', 'lang', 'stage', 'subject', 'resource', 'format', 'checking_level', 'book', 'metadata_type', 'metadata_version', 'partial_match', 'include_history', 'show_ingredients', 'sort', 'order', 'page', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_search" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'q' in params:
            query_params.append(('q', params['q']))  # noqa: E501
        if 'owner' in params:
            query_params.append(('owner', params['owner']))  # noqa: E501
        if 'repo' in params:
            query_params.append(('repo', params['repo']))  # noqa: E501
        if 'tag' in params:
            query_params.append(('tag', params['tag']))  # noqa: E501
        if 'lang' in params:
            query_params.append(('lang', params['lang']))  # noqa: E501
        if 'stage' in params:
            query_params.append(('stage', params['stage']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'resource' in params:
            query_params.append(('resource', params['resource']))  # noqa: E501
        if 'format' in params:
            query_params.append(('format', params['format']))  # noqa: E501
        if 'checking_level' in params:
            query_params.append(('checkingLevel', params['checking_level']))  # noqa: E501
        if 'book' in params:
            query_params.append(('book', params['book']))  # noqa: E501
        if 'metadata_type' in params:
            query_params.append(('metadataType', params['metadata_type']))  # noqa: E501
        if 'metadata_version' in params:
            query_params.append(('metadataVersion', params['metadata_version']))  # noqa: E501
        if 'partial_match' in params:
            query_params.append(('partialMatch', params['partial_match']))  # noqa: E501
        if 'include_history' in params:
            query_params.append(('includeHistory', params['include_history']))  # noqa: E501
        if 'show_ingredients' in params:
            query_params.append(('showIngredients', params['show_ingredients']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order' in params:
            query_params.append(('order', params['order']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/search', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CatalogSearchResults',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_search_owner(self, owner, **kwargs):  # noqa: E501
        """Catalog search by owner  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search_owner(owner, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: owner of the returned entries (required)
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str repo: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" -return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_search_owner_with_http_info(owner, **kwargs)  # noqa: E501
        else:
            (data) = self.catalog_search_owner_with_http_info(owner, **kwargs)  # noqa: E501
            return data

    def catalog_search_owner_with_http_info(self, owner, **kwargs):  # noqa: E501
        """Catalog search by owner  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search_owner_with_http_info(owner, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: owner of the returned entries (required)
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str repo: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" -return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). . <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'q', 'repo', 'tag', 'lang', 'stage', 'subject', 'resource', 'format', 'checking_level', 'book', 'metadata_type', 'metadata_version', 'partial_match', 'include_history', 'show_ingredients', 'sort', 'order', 'page', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_search_owner" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if self.api_client.client_side_validation and ('owner' not in params or
                                                       params['owner'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `owner` when calling `catalog_search_owner`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']  # noqa: E501

        query_params = []
        if 'q' in params:
            query_params.append(('q', params['q']))  # noqa: E501
        if 'repo' in params:
            query_params.append(('repo', params['repo']))  # noqa: E501
        if 'tag' in params:
            query_params.append(('tag', params['tag']))  # noqa: E501
        if 'lang' in params:
            query_params.append(('lang', params['lang']))  # noqa: E501
        if 'stage' in params:
            query_params.append(('stage', params['stage']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'resource' in params:
            query_params.append(('resource', params['resource']))  # noqa: E501
        if 'format' in params:
            query_params.append(('format', params['format']))  # noqa: E501
        if 'checking_level' in params:
            query_params.append(('checkingLevel', params['checking_level']))  # noqa: E501
        if 'book' in params:
            query_params.append(('book', params['book']))  # noqa: E501
        if 'metadata_type' in params:
            query_params.append(('metadataType', params['metadata_type']))  # noqa: E501
        if 'metadata_version' in params:
            query_params.append(('metadataVersion', params['metadata_version']))  # noqa: E501
        if 'partial_match' in params:
            query_params.append(('partialMatch', params['partial_match']))  # noqa: E501
        if 'include_history' in params:
            query_params.append(('includeHistory', params['include_history']))  # noqa: E501
        if 'show_ingredients' in params:
            query_params.append(('showIngredients', params['show_ingredients']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order' in params:
            query_params.append(('order', params['order']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/search/{owner}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CatalogSearchResults',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def catalog_search_repo(self, owner, repo, **kwargs):  # noqa: E501
        """Catalog search by repo  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search_repo(owner, repo, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: owner of the returned entries (required)
        :param str repo: name of the repo of the returned entries (required)
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str owner2: search only for entries with the given owner name(s). Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str repo2: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" -return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.catalog_search_repo_with_http_info(owner, repo, **kwargs)  # noqa: E501
        else:
            (data) = self.catalog_search_repo_with_http_info(owner, repo, **kwargs)  # noqa: E501
            return data

    def catalog_search_repo_with_http_info(self, owner, repo, **kwargs):  # noqa: E501
        """Catalog search by repo  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.catalog_search_repo_with_http_info(owner, repo, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner: owner of the returned entries (required)
        :param str repo: name of the repo of the returned entries (required)
        :param str q: keyword(s). Can use multiple `q=<keyword>`s or a comma-delimited string for more than one keyword. Is case insensitive
        :param str owner2: search only for entries with the given owner name(s). Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str repo2: search only for entries with the given repo name(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str tag: search only for entries with the given release tag(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str lang: search only for entries with the given language(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str stage: specifies which release stage to be return of these stages: \"prod\" - return only the production releases (default); \"preprod\" - return the pre-production release if it exists instead of the production release; \"draft\" - return the draft release if it exists instead of pre-production or production release; \"latest\" -return the default branch (e.g. master) if it is a valid RC instead of the above
        :param str subject: search only for entries with the given subject(s). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive) unlesss partialMatch=true
        :param str resource: resource identifier. Multiple resources are ORed.
        :param str format: content format (usfm, text, markdown, etc.). Multiple formats are ORed.
        :param str checking_level: search only for entries with the given checking level(s). Can be 1, 2 or 3
        :param str book: search only for entries with the given book(s) (project ids). To match multiple, give the parameter multiple times or give a list comma delimited. Will perform an exact match (case insensitive)
        :param str metadata_type: return repos only with metadata of this type (e.g. rc, tc, ts, sb). <empty> or \"all\" for all. Default is rc
        :param str metadata_version: return repos only with the version of metadata given. Does not apply if metadataType is \"all\"
        :param bool partial_match: if true, subject, owner and repo search fields will use partial match (LIKE) when querying the catalog. Default is false
        :param bool include_history: if true, all releases, not just the latest, are included. Default is false
        :param bool show_ingredients: if true, the list of ingredients (files/projects) in the resource and their file paths will be listed for each entry. Default is true
        :param str sort: sort repos alphanumerically by attribute. Supported values are \"subject\", \"title\", \"reponame\", \"tag\", \"released\", \"lang\", \"releases\", \"stars\", \"forks\". Default is by \"language\", \"subject\" and then \"tag\"
        :param str order: sort order, either \"asc\" (ascending) or \"desc\" (descending). Default is \"asc\", ignored if \"sort\" is not specified.
        :param int page: page number of results to return (1-based)
        :param int limit: page size of results, defaults to no limit
        :return: CatalogSearchResults
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'q', 'owner2', 'repo2', 'tag', 'lang', 'stage', 'subject', 'resource', 'format', 'checking_level', 'book', 'metadata_type', 'metadata_version', 'partial_match', 'include_history', 'show_ingredients', 'sort', 'order', 'page', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method catalog_search_repo" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if self.api_client.client_side_validation and ('owner' not in params or
                                                       params['owner'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `owner` when calling `catalog_search_repo`")  # noqa: E501
        # verify the required parameter 'repo' is set
        if self.api_client.client_side_validation and ('repo' not in params or
                                                       params['repo'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `repo` when calling `catalog_search_repo`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']  # noqa: E501
        if 'repo' in params:
            path_params['repo'] = params['repo']  # noqa: E501

        query_params = []
        if 'q' in params:
            query_params.append(('q', params['q']))  # noqa: E501
        if 'owner2' in params:
            query_params.append(('owner', params['owner2']))  # noqa: E501
        if 'repo2' in params:
            query_params.append(('repo', params['repo2']))  # noqa: E501
        if 'tag' in params:
            query_params.append(('tag', params['tag']))  # noqa: E501
        if 'lang' in params:
            query_params.append(('lang', params['lang']))  # noqa: E501
        if 'stage' in params:
            query_params.append(('stage', params['stage']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'resource' in params:
            query_params.append(('resource', params['resource']))  # noqa: E501
        if 'format' in params:
            query_params.append(('format', params['format']))  # noqa: E501
        if 'checking_level' in params:
            query_params.append(('checkingLevel', params['checking_level']))  # noqa: E501
        if 'book' in params:
            query_params.append(('book', params['book']))  # noqa: E501
        if 'metadata_type' in params:
            query_params.append(('metadataType', params['metadata_type']))  # noqa: E501
        if 'metadata_version' in params:
            query_params.append(('metadataVersion', params['metadata_version']))  # noqa: E501
        if 'partial_match' in params:
            query_params.append(('partialMatch', params['partial_match']))  # noqa: E501
        if 'include_history' in params:
            query_params.append(('includeHistory', params['include_history']))  # noqa: E501
        if 'show_ingredients' in params:
            query_params.append(('showIngredients', params['show_ingredients']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order' in params:
            query_params.append(('order', params['order']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'text/plain'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'AuthorizationHeaderToken', 'BasicAuth', 'SudoHeader', 'SudoParam', 'TOTPHeader', 'Token']  # noqa: E501

        return self.api_client.call_api(
            '/catalog/search/{owner}/{repo}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CatalogSearchResults',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
